/*
 * Definition Module for the 8255 chip
 *
 */

/*==================================================*/
header "8255_IORegs" /{

#define PORT1_A  (base+0)
#define PORT1_B  (base+1)
#define PORT1_C  (base+2)
#define PORT1_CR (base+3)

#define PORT2_A  (base+4)
#define PORT2_B  (base+5)
#define PORT2_C  (base+6)
#define PORT2_CR (base+7)

}/
/*==================================================*/
header "8255_Modes" /{

#define C_LSB_MODE (1<<0)
#define B_IO_MODE  (1<<1)
#define B_MODESEL  (1<<2)
#define C_MSB_MODE (1<<3)
#define A_IO_MODE  (1<<4)
#define A_MODESEL  (1<<5)
#define A_BIDIR    (1<<6)

#define MODE_SET   (1<<7)

}/
/*==================================================*/
file "8255_Globals" /{

int mode_shadow=0;


}/

/*==================================================*/
driver "8255" [minor] {
	open  /{}/
	close /{}/
	ioctl {
		func Reset() /{ }/
		func SetMode(int port,char val) /{}/
		func Write(int port,char val) /{}/
		func Read(int port) /{}/
        }
}


