 /*
  * Generated with LDDK Version 0.1-beta 
  *     (c) 1996 Claus Schroeter (clausi@chemie.fu-berlin.de) 
  */
#include <SmartLab_P.h>



int 8255_ioctl(struct inode* inode,struct file* file , unsigned int cmd, unsigned long arg )
{
  void *argp;
  int retval;

  

  DBGin("8255_ioctl");
  DBGprint(DBG_DATA,("cmd=%d",cmd));

  

  switch(cmd){

        case RESET:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Reset_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Reset_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Reset_par_t) +1 ,GFP_KERNEL );
              memcpy_fromfs( (void *) argp, (Reset_par_t *) arg, sizeof(Reset_par_t));
              ((Reset_par_t *) argp)->retval = 8255_Reset(  );
              memcpy_tofs( (Reset_par_t *) arg, (void *) argp, sizeof(Reset_par_t));
              kfree(argp);
              break;
      case SETMODE:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(SetMode_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(SetMode_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(SetMode_par_t) +1 ,GFP_KERNEL );
              memcpy_fromfs( (void *) argp, (SetMode_par_t *) arg, sizeof(SetMode_par_t));
              ((SetMode_par_t *) argp)->retval = 8255_SetMode(  ((SetMode_par_t *) argp)->port, 
				 ((SetMode_par_t *) argp)->val );
              memcpy_tofs( (SetMode_par_t *) arg, (void *) argp, sizeof(SetMode_par_t));
              kfree(argp);
              break;
      case WRITE:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Write_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Write_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Write_par_t) +1 ,GFP_KERNEL );
              memcpy_fromfs( (void *) argp, (Write_par_t *) arg, sizeof(Write_par_t));
              ((Write_par_t *) argp)->retval = 8255_Write(  ((Write_par_t *) argp)->port, 
				 ((Write_par_t *) argp)->val );
              memcpy_tofs( (Write_par_t *) arg, (void *) argp, sizeof(Write_par_t));
              kfree(argp);
              break;
      case READ:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Read_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Read_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Read_par_t) +1 ,GFP_KERNEL );
              memcpy_fromfs( (void *) argp, (Read_par_t *) arg, sizeof(Read_par_t));
              ((Read_par_t *) argp)->retval = 8255_Read(  ((Read_par_t *) argp)->port );
              memcpy_tofs( (Read_par_t *) arg, (void *) argp, sizeof(Read_par_t));
              kfree(argp);
              break;

  
  

  default:
    DBGout();	
    return -EINVAL;
  }
  
  

  DBGout();
  return 1;

}
